<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "device".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Device".
 *
 * Columns in table "device" available as properties of the model,
 * followed by relations of table "device" available as properties of the model.
 *
 * @property integer $id
 * @property string $status
 * @property string $device_model_id
 * @property string $nickname
 * @property string $serial_number
 * @property float $price
 * @property string $date_added
 * @property string $notes
 *
 * @property AccountDevice[] $accountDevices
 * @property DeviceModel $deviceModel
 * @property DeviceHistory[] $deviceHistories
 */
abstract class BaseDevice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'device';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Device|Devices', $n);
    }

    public static function representingColumn()
    {
        return 'status';
    }

    public function rules()
    {
        return array(
            array('device_model_id, nickname, serial_number', 'required'),
            array('status', 'length', 'max' => 1),
            array('device_model_id', 'length', 'max' => 11),
            array('nickname', 'length', 'max' => 100),
            array('serial_number', 'length', 'max' => 50),
            array('date_added, notes, price', 'safe'),
            array('status, date_added, notes', 'default', 'setOnEmpty' => true, 'value' => null),
            array(
                'id, status, device_model_id, nickname, serial_number, price, date_added, notes',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'accountDevices' => array(self::HAS_MANY, 'AccountDevice', 'device_id'),
            'deviceModel' => array(self::BELONGS_TO, 'DeviceModel', 'device_model_id'),
            'deviceHistories' => array(self::HAS_MANY, 'DeviceHistory', 'device_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'status' => Yii::t('app', 'Status'),
            'device_model_id' => null,
            'nickname' => Yii::t('app', 'Nickname'),
            'serial_number' => Yii::t('app', 'Serial Number'),
            'date_added' => Yii::t('app', 'Date Added'),
            'price' => Yii::t('app', 'Unit Price (USD)'),
            'notes' => Yii::t('app', 'Notes'),
            'accountDevices' => null,
            'deviceModel' => null,
            'deviceHistories' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('device_model_id', $this->device_model_id);
        $criteria->compare('nickname', $this->nickname, true);
        $criteria->compare('serial_number', $this->serial_number, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('price', $this->price, true);
        $criteria->compare('notes', $this->notes, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }
}
